### Method

# EDataServer Source store_password

since: 3.12

#### Declaration [src]

    void
    e_source_store_password (
      ESource* source,
      const gchar* password,
      gboolean permanently,
      GCancellable* cancellable,
      GAsyncReadyCallback callback,
      gpointer user_data
    )

#### Description [src]

Asynchronously stores a password for `source`. This operation does not rely on the registry service and therefore works for any `ESource` — registered or “scratch”.

If `permanently` is `TRUE`, the password is stored in the default keyring. Otherwise the password is stored in the memory-only session keyring. If an error occurs, the function sets `error` and returns `FALSE`.

When the operation is finished, `callback` will be called. You can then call `e_source_store_password_finish()` to get the result of the operation.

Available since: 3.12

This method completes asynchronously. Use `e_source_store_password_finish()` inside the `GAsyncReadyCallback` to obtain the result of the operation.

#### Parameters

`password`

  Type: `const gchar*`

  The password to store.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`permanently`

  Type: `gboolean`

  Store permanently or just for the session.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`callback`

  Type: `GAsyncReadyCallback`

  A `GAsyncReadyCallback` to call when the request is satisfied.

  The argument can be `NULL`.

`user_data`

  Type: `gpointer`

  Data to pass to the callback function.

  The argument can be `NULL`.
  The data is owned by the caller of the method.